=== debian/changelog ===
kodi (2:18.5+dfsg1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 10 Feb 2020 08:02:56 -0800

kodi (2:18.5+dfsg1-1~exp0) experimental; urgency=medium

  [ Balint Reczey ]
  * Team upload
  * debian/tests/gui: Wait for kodi to start, not just a fixed 5 seconds
  * Refresh patches
  * Update extra libdvdnav and libdvdread original tarballs
  * debian/copyright_hints: Update hints with new files
  * debian/control: Tidy up using cme fix
  * debian/gitlab-ci.yml: Add Salsa CI configuration
  * Refresh build dependencies based on upstream's packaging
  * Ship separate packages for X11, Wayland and GBM
  * debian/rules:
    - Rewrite to use cmake and build separate binaries.
      Thanks to Wolfgang Schupp
    - Extend override_dh_clean
    - Pass -lphtread to linker by default
    - Refactor building Debianized artifacts
    - Run tests for each build dir
    - Clean up separate build directories
    - clean media/Fonts/arial.ttf, too
    - Call dh with python2
    - Drop obsolete --parallel dh argument
    - Adjust to new component names
  * debian/copyright: Fix open issues and Lintian complaints
  * Let upstream's build system build the embedded libdvdnav and libread
    libraries
  * Install TexturePacker to /usr/bin/
  * Ignore failing tests for now
  * Update which files are shipped by which package
  * Switch hashing implementation from OpenSSL to Libgcrypt
  * Build without OpenSSL
  * Depend on unhinted Roboto font (Closes: #922950)
  * Fix FTBFS of kodi-test by not #include-ing excluded Windows-only header
  * Fix dh_kodiaddon_depends to get API versions the new way
  * Refresh file list shipped by kodi-addons-dev
  * Remove myself from Uploaders
  * Work around FTBFS caused by fontforge SEGFAULT
  * New upstream version 18.5+dfsg1
  * debian/gbp.conf: Drop postexport hook.
    It is obsoleted by storing all components in git.
  * Stop marking kodi-bin Multiarch: same since it now ships TexturePacker
  * Stop marking kodi-gbm, kodi-x11 and kodi-wayland Multiarch: same.
    They depend on kodi-bin which is not Multiarch: same either.
  * Build kodi-wayland, too

  [ Rechi ]
  * debian/copyright: update Files-Excluded
    - libUPnP was updated
    - UnrarXLib was split into an addon
    - Visual Studio files were removed
    - windows platform specific code location changed
  * drop unused Build-depends
  * add new Build-depends
  * debian/rules: remove unused DEB vars
  * debian/rules: remove non existent cmake options
    - egl is a required dependency on linux so there is no ENABLE_EGL switch
    - x11 isn't an optional dependency for gbm so there is no ENABLE_X11 switch
    - vdpau is only an optional dependency for x11, so ENABLE_VDPAU switch
      exists only for x11
  * debian/rules: update dlopened libs
    libass, libbluray, libcec, libcurl and libnfs are no longer dlopend
  * fix libmicrohttpd linking
  * debian/rules: install kodi-x11 as last package
    last installed package defines the fallback windowing in bin/kodi
  * fix depends syntax
  * fix test target build system dependency

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 24 Jan 2020 08:20:58 +0100
