=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-bindnow
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
 # Use package's version in Kodi
 VERSION := $(shell dpkg-parsechangelog -S Version)
@@ -37,10 +38,22 @@
 # for embedded libdvd*:
 export DEB_CPPFLAGS_MAINT_APPEND = -D_XBMC
 
+ifneq (,$(filter armel armhf,$(DEB_HOST_ARCH)))
+EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=arm
+else ifneq (,$(filter ppc64el,$(DEB_HOST_ARCH)))
+EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=ppc64
+else ifneq (,$(filter s390x,$(DEB_HOST_ARCH)))
+EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=s390x
+else ifneq (,$(filter mipsel,$(DEB_HOST_ARCH)))
+EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=mips
+else ifneq (,$(filter mips64el,$(DEB_HOST_ARCH)))
+EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=mips64
+endif
+
 KODI_OPTS=\
 -DVERBOSE=1 \
 -DUSE_LTO=${NUMCPU} \
--DCMAKE_BUILD_TYPE=Release \
+-DCMAKE_BUILD_TYPE=RelWithDebInfo \
 -DENABLE_AIRTUNES=ON \
 -DENABLE_ALSA=ON \
 -DENABLE_AVAHI=ON \
@@ -64,6 +77,7 @@
 -DLIBDVDREAD_URL=${DVDREAD_URL} \
 -DLIBDVDNAV_URL=${DVDNAV_URL} \
 -DENABLE_LIRCCLIENT=ON \
+-DNEON=False \
 $(EXTRA_FLAGS)
 
 X11_OPTS=\
@@ -79,7 +93,7 @@
 -DGBM_RENDER_SYSTEM=gl
 
 %:
-	dh $@ --buildsystem cmake --with python2
+	dh $@ --buildsystem cmake --with python2,python3
 
 override_dh_clean:
 	dh_clean \
@@ -103,10 +117,10 @@
 
 media/Fonts/arial.ttf: debian/mergefonts.ff
 	# work around #948876 until fontforge is fixed by using cached result
-#	! fontforge -script $< \
-#		/usr/share/fonts/truetype/droid/DroidSansFallbackFull.ttf \
-#		$(DEJAVUSANS) \
-#		$@ && cp debian/extra/arial.ttf $@
+	! fontforge -script $< \
+		/usr/share/fonts/truetype/droid/DroidSansFallbackFull.ttf \
+		$(DEJAVUSANS) \
+		$@ && cp debian/extra/arial.ttf $@
 
 lib/gtest/lib/.libs/libgtest.a:
 	cp -r /usr/src/gtest/ $(CURDIR)/lib/ && mkdir -p $(CURDIR)/lib/gtest/lib/.libs
@@ -140,12 +154,12 @@
 	done
 
 override_dh_auto_test-arch:
-	-dh_auto_test -a --builddir kodi_build_x11
-ifeq ($(BUILD_WAYLAND),yes)
-	-dh_auto_test -a --builddir kodi_build_wayland
-endif
-ifeq ($(BUILD_GBM),yes)
-	-dh_auto_test -a --builddir kodi_build_gbm
+	dh_auto_test -a --builddir kodi_build_x11
+ifeq ($(BUILD_WAYLAND),yes)
+	dh_auto_test -a --builddir kodi_build_wayland
+endif
+ifeq ($(BUILD_GBM),yes)
+	dh_auto_test -a --builddir kodi_build_gbm
 endif
 
 # No tests for indep build.
@@ -182,9 +196,9 @@
 	# ship xbmcclient.h only in kodi-eventclients-dev
 	rm -f debian/kodi-addons-dev/usr/include/kodi/xbmcclient.h
 	# check if all needed headers are included
-#	$(CXX) -c debian/headers-check.c -DBUILD_KODI_ADDON \
-#	$(shell dpkg-buildflags --get CPPFLAGS) \
-#	$(shell dpkg-buildflags --get CXXFLAGS) \
+	$(CXX) -c debian/headers-check.c -DBUILD_KODI_ADDON \
+	$(shell dpkg-buildflags --get CPPFLAGS) \
+	$(shell dpkg-buildflags --get CXXFLAGS) \
 	-Idebian/kodi-addons-dev/usr/include \
 	-o /dev/null
 
@@ -215,9 +229,6 @@
 	sed -Ei '/kodi-(wayland|gbm)_/d' debian/files
 endif
 
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-
 override_dh_gencontrol-arch:
 	debian/dh-addon/dh_kodiaddon_depends
 	dh_gencontrol -a
@@ -230,5 +241,3 @@
 	tar -xf $(CURDIR)/../kodi_"$(UPSTREAM_VERSION)".orig-$(DVDNAV_COMPONENT).tar.xz && \
 		test -d $(CURDIR)/$(DVDNAV_COMPONENT) || mv libdvdnav-* $(CURDIR)/$(DVDNAV_COMPONENT)
 	tar -xf $(CURDIR)/../kodi_"$(UPSTREAM_VERSION)".orig-$(DVDREAD_COMPONENT).tar.xz && \
-		test -d $(CURDIR)/$(DVDREAD_COMPONENT) || mv libdvdread-* $(CURDIR)/$(DVDREAD_COMPONENT)
-	tar -xf $(CURDIR)/../kodi_"$(UPSTREAM_VERSION)".orig-webinterface-default.tar.xz
